/*
Copyright The Kubernetes Authors.

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
*/

// Code generated by client-gen. DO NOT EDIT.

package fake

import (
	"context"

	kubeovnv1 "github.com/kubeovn/kube-ovn/pkg/apis/kubeovn/v1"
	v1 "k8s.io/apimachinery/pkg/apis/meta/v1"
	labels "k8s.io/apimachinery/pkg/labels"
	schema "k8s.io/apimachinery/pkg/runtime/schema"
	types "k8s.io/apimachinery/pkg/types"
	watch "k8s.io/apimachinery/pkg/watch"
	testing "k8s.io/client-go/testing"
)

// FakeVlans implements VlanInterface
type FakeVlans struct {
	Fake *FakeKubeovnV1
}

var vlansResource = schema.GroupVersionResource{Group: "kubeovn.io", Version: "v1", Resource: "vlans"}

var vlansKind = schema.GroupVersionKind{Group: "kubeovn.io", Version: "v1", Kind: "Vlan"}

// Get takes name of the vlan, and returns the corresponding vlan object, and an error if there is any.
func (c *FakeVlans) Get(ctx context.Context, name string, options v1.GetOptions) (result *kubeovnv1.Vlan, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewRootGetAction(vlansResource, name), &kubeovnv1.Vlan{})
	if obj == nil {
		return nil, err
	}
	return obj.(*kubeovnv1.Vlan), err
}

// List takes label and field selectors, and returns the list of Vlans that match those selectors.
func (c *FakeVlans) List(ctx context.Context, opts v1.ListOptions) (result *kubeovnv1.VlanList, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewRootListAction(vlansResource, vlansKind, opts), &kubeovnv1.VlanList{})
	if obj == nil {
		return nil, err
	}

	label, _, _ := testing.ExtractFromListOptions(opts)
	if label == nil {
		label = labels.Everything()
	}
	list := &kubeovnv1.VlanList{ListMeta: obj.(*kubeovnv1.VlanList).ListMeta}
	for _, item := range obj.(*kubeovnv1.VlanList).Items {
		if label.Matches(labels.Set(item.Labels)) {
			list.Items = append(list.Items, item)
		}
	}
	return list, err
}

// Watch returns a watch.Interface that watches the requested vlans.
func (c *FakeVlans) Watch(ctx context.Context, opts v1.ListOptions) (watch.Interface, error) {
	return c.Fake.
		InvokesWatch(testing.NewRootWatchAction(vlansResource, opts))
}

// Create takes the representation of a vlan and creates it.  Returns the server's representation of the vlan, and an error, if there is any.
func (c *FakeVlans) Create(ctx context.Context, vlan *kubeovnv1.Vlan, opts v1.CreateOptions) (result *kubeovnv1.Vlan, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewRootCreateAction(vlansResource, vlan), &kubeovnv1.Vlan{})
	if obj == nil {
		return nil, err
	}
	return obj.(*kubeovnv1.Vlan), err
}

// Update takes the representation of a vlan and updates it. Returns the server's representation of the vlan, and an error, if there is any.
func (c *FakeVlans) Update(ctx context.Context, vlan *kubeovnv1.Vlan, opts v1.UpdateOptions) (result *kubeovnv1.Vlan, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewRootUpdateAction(vlansResource, vlan), &kubeovnv1.Vlan{})
	if obj == nil {
		return nil, err
	}
	return obj.(*kubeovnv1.Vlan), err
}

// UpdateStatus was generated because the type contains a Status member.
// Add a +genclient:noStatus comment above the type to avoid generating UpdateStatus().
func (c *FakeVlans) UpdateStatus(ctx context.Context, vlan *kubeovnv1.Vlan, opts v1.UpdateOptions) (*kubeovnv1.Vlan, error) {
	obj, err := c.Fake.
		Invokes(testing.NewRootUpdateSubresourceAction(vlansResource, "status", vlan), &kubeovnv1.Vlan{})
	if obj == nil {
		return nil, err
	}
	return obj.(*kubeovnv1.Vlan), err
}

// Delete takes name of the vlan and deletes it. Returns an error if one occurs.
func (c *FakeVlans) Delete(ctx context.Context, name string, opts v1.DeleteOptions) error {
	_, err := c.Fake.
		Invokes(testing.NewRootDeleteActionWithOptions(vlansResource, name, opts), &kubeovnv1.Vlan{})
	return err
}

// DeleteCollection deletes a collection of objects.
func (c *FakeVlans) DeleteCollection(ctx context.Context, opts v1.DeleteOptions, listOpts v1.ListOptions) error {
	action := testing.NewRootDeleteCollectionAction(vlansResource, listOpts)

	_, err := c.Fake.Invokes(action, &kubeovnv1.VlanList{})
	return err
}

// Patch applies the patch and returns the patched vlan.
func (c *FakeVlans) Patch(ctx context.Context, name string, pt types.PatchType, data []byte, opts v1.PatchOptions, subresources ...string) (result *kubeovnv1.Vlan, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewRootPatchSubresourceAction(vlansResource, name, pt, data, subresources...), &kubeovnv1.Vlan{})
	if obj == nil {
		return nil, err
	}
	return obj.(*kubeovnv1.Vlan), err
}
